# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/ComputeBoxGraspsRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_pick_client.msg

class ComputeBoxGraspsRequest(genpy.Message):
  _md5sum = "dfc716b88b5b15420b4f08377670aab4"
  _type = "rc_pick_client/ComputeBoxGraspsRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """







string pose_frame


string region_of_interest_id


string load_carrier_id


Compartment load_carrier_compartment


BoxModel[] item_models




float64 suction_surface_length
float64 suction_surface_width


geometry_msgs/Pose robot_pose


================================================================================
MSG: rc_pick_client/Compartment
# Definition of a compartment (Primitive type without pose_frame and type)
# type is implicit since currently only Box type is supported
# the pose is relative to the pose_frame of the object including the compartment

# Required
# string type

# Supported types
# All primitives are defined to have their bounding boxes centered around (0,0,0)
string BOX=BOX
# string SPHERE=SPHERE
# string CYLINDER=CYLINDER
# string CONE=CONE

# Optional: if not specified, the pose is relative to the pose_frame of the object including the primitive
# string pose_frame

# Optional: identity transformation assumed if not provided
geometry_msgs/Pose pose

# Only one of those required depending on the selected type
Box box
# Sphere sphere
# Cylinder cylinder
# Cone cone

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_pick_client/BoxModel
# Definition of a box model for the boxpick component

# Required
string type

# Required
RangeRectangle rectangle

================================================================================
MSG: rc_pick_client/RangeRectangle
# Definition of a rectangle with minimum and maximum dimensions

Rectangle min_dimensions
Rectangle max_dimensions

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y
"""
  __slots__ = ['pose_frame','region_of_interest_id','load_carrier_id','load_carrier_compartment','item_models','suction_surface_length','suction_surface_width','robot_pose']
  _slot_types = ['string','string','string','rc_pick_client/Compartment','rc_pick_client/BoxModel[]','float64','float64','geometry_msgs/Pose']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       pose_frame,region_of_interest_id,load_carrier_id,load_carrier_compartment,item_models,suction_surface_length,suction_surface_width,robot_pose

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ComputeBoxGraspsRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.pose_frame is None:
        self.pose_frame = ''
      if self.region_of_interest_id is None:
        self.region_of_interest_id = ''
      if self.load_carrier_id is None:
        self.load_carrier_id = ''
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.item_models is None:
        self.item_models = []
      if self.suction_surface_length is None:
        self.suction_surface_length = 0.
      if self.suction_surface_width is None:
        self.suction_surface_width = 0.
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
    else:
      self.pose_frame = ''
      self.region_of_interest_id = ''
      self.load_carrier_id = ''
      self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      self.item_models = []
      self.suction_surface_length = 0.
      self.suction_surface_width = 0.
      self.robot_pose = geometry_msgs.msg.Pose()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.load_carrier_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z))
      length = len(self.item_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.item_models:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v1 = val1.rectangle
        _v2 = _v1.min_dimensions
        _x = _v2
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v3 = _v1.max_dimensions
        _x = _v3
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_9d().pack(_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.item_models is None:
        self.item_models = None
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier_id = str[start:end].decode('utf-8')
      else:
        self.load_carrier_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.item_models = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.BoxModel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        _v4 = val1.rectangle
        _v5 = _v4.min_dimensions
        _x = _v5
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v6 = _v4.max_dimensions
        _x = _v6
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        self.item_models.append(val1)
      _x = self
      start = end
      end += 72
      (_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w,) = _get_struct_9d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.load_carrier_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_10d().pack(_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z))
      length = len(self.item_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.item_models:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v7 = val1.rectangle
        _v8 = _v7.min_dimensions
        _x = _v8
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v9 = _v7.max_dimensions
        _x = _v9
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_9d().pack(_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.item_models is None:
        self.item_models = None
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier_id = str[start:end].decode('utf-8')
      else:
        self.load_carrier_id = str[start:end]
      _x = self
      start = end
      end += 80
      (_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.item_models = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.BoxModel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        _v10 = val1.rectangle
        _v11 = _v10.min_dimensions
        _x = _v11
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v12 = _v10.max_dimensions
        _x = _v12
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        self.item_models.append(val1)
      _x = self
      start = end
      end += 72
      (_x.suction_surface_length, _x.suction_surface_width, _x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w,) = _get_struct_9d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_9d = None
def _get_struct_9d():
    global _struct_9d
    if _struct_9d is None:
        _struct_9d = struct.Struct("<9d")
    return _struct_9d
_struct_10d = None
def _get_struct_10d():
    global _struct_10d
    if _struct_10d is None:
        _struct_10d = struct.Struct("<10d")
    return _struct_10d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/ComputeBoxGraspsResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rc_common_msgs.msg
import geometry_msgs.msg
import genpy
import rc_pick_client.msg
import std_msgs.msg

class ComputeBoxGraspsResponse(genpy.Message):
  _md5sum = "c3d639f054b4b395c3646a18ccb72402"
  _type = "rc_pick_client/ComputeBoxGraspsResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
time timestamp

LoadCarrier[] load_carriers

BoxItem[] items

SuctionGrasp[] grasps

rc_common_msgs/ReturnCode return_code


================================================================================
MSG: rc_pick_client/LoadCarrier
# This represents a load carrier by its geometry and its pose in the pose_frame reference frame

string id

# Required
Box outer_dimensions

# Required
Box inner_dimensions

# Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
Rectangle rim_thickness

geometry_msgs/PoseStamped pose

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_pick_client/BoxItem
# Definition of a box item for the boxpick component

# Optional
string[] grasp_uuids

# Required. The pose of the box item
geometry_msgs/Pose pose

# Required
string pose_frame

# Required
Rectangle rectangle

# Required
time timestamp

# Required
string type

# Required
string uuid

================================================================================
MSG: rc_pick_client/SuctionGrasp
# Definition of a suction grasp for the itempick component

string uuid

# Optional
string item_uuid

# The grasp orientation is defined such that:
# - the z axis is the normal of the surface at the grasp position
# - the x axis is directed along the direction of maximum elongation of the surface
# - the y axis is selected to form a right-handed coordinate system
geometry_msgs/PoseStamped pose

# Optional. The quality of the grasp (between 0 and 1)
float64 quality

# Optional. The axis lengths of the biggest ellipse inscribed on the suction surface
float64 max_suction_surface_length
float64 max_suction_surface_width

================================================================================
MSG: rc_common_msgs/ReturnCode
# This message shall be used in the response of services as a field called return_code.
# Confer to ReturnCodeConsts message for commonly used return code definitions.

# return codes
# >=0 - success
# < 0 - failure

# return code
int16 value

# return message
string message
"""
  __slots__ = ['timestamp','load_carriers','items','grasps','return_code']
  _slot_types = ['time','rc_pick_client/LoadCarrier[]','rc_pick_client/BoxItem[]','rc_pick_client/SuctionGrasp[]','rc_common_msgs/ReturnCode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       timestamp,load_carriers,items,grasps,return_code

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ComputeBoxGraspsResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = []
      if self.items is None:
        self.items = []
      if self.grasps is None:
        self.grasps = []
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
    else:
      self.timestamp = genpy.Time()
      self.load_carriers = []
      self.items = []
      self.grasps = []
      self.return_code = rc_common_msgs.msg.ReturnCode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v13 = val1.outer_dimensions
        _x = _v13
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v14 = val1.inner_dimensions
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v15 = val1.rim_thickness
        _x = _v15
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v16 = val1.pose
        _v17 = _v16.header
        buff.write(_get_struct_I().pack(_v17.seq))
        _v18 = _v17.stamp
        _x = _v18
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v17.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v19 = _v16.pose
        _v20 = _v19.position
        _x = _v20
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v21 = _v19.orientation
        _x = _v21
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      length = len(self.items)
      buff.write(_struct_I.pack(length))
      for val1 in self.items:
        length = len(val1.grasp_uuids)
        buff.write(_struct_I.pack(length))
        for val2 in val1.grasp_uuids:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
        _v22 = val1.pose
        _v23 = _v22.position
        _x = _v23
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v24 = _v22.orientation
        _x = _v24
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.pose_frame
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v25 = val1.rectangle
        _x = _v25
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v26 = val1.timestamp
        _x = _v26
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasps:
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.item_uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v27 = val1.pose
        _v28 = _v27.header
        buff.write(_get_struct_I().pack(_v28.seq))
        _v29 = _v28.stamp
        _x = _v29
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v28.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v30 = _v27.pose
        _v31 = _v30.position
        _x = _v31
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v32 = _v30.orientation
        _x = _v32
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_3d().pack(_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width))
      buff.write(_get_struct_h().pack(self.return_code.value))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = None
      if self.items is None:
        self.items = None
      if self.grasps is None:
        self.grasps = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.LoadCarrier()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8')
        else:
          val1.id = str[start:end]
        _v33 = val1.outer_dimensions
        _x = _v33
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v34 = val1.inner_dimensions
        _x = _v34
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v35 = val1.rim_thickness
        _x = _v35
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v36 = val1.pose
        _v37 = _v36.header
        start = end
        end += 4
        (_v37.seq,) = _get_struct_I().unpack(str[start:end])
        _v38 = _v37.stamp
        _x = _v38
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v37.frame_id = str[start:end].decode('utf-8')
        else:
          _v37.frame_id = str[start:end]
        _v39 = _v36.pose
        _v40 = _v39.position
        _x = _v40
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v41 = _v39.orientation
        _x = _v41
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.load_carriers.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.items = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.BoxItem()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.grasp_uuids = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.grasp_uuids.append(val2)
        _v42 = val1.pose
        _v43 = _v42.position
        _x = _v43
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v44 = _v42.orientation
        _x = _v44
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.pose_frame = str[start:end].decode('utf-8')
        else:
          val1.pose_frame = str[start:end]
        _v45 = val1.rectangle
        _x = _v45
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v46 = val1.timestamp
        _x = _v46
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8')
        else:
          val1.uuid = str[start:end]
        self.items.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasps = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.SuctionGrasp()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8')
        else:
          val1.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.item_uuid = str[start:end].decode('utf-8')
        else:
          val1.item_uuid = str[start:end]
        _v47 = val1.pose
        _v48 = _v47.header
        start = end
        end += 4
        (_v48.seq,) = _get_struct_I().unpack(str[start:end])
        _v49 = _v48.stamp
        _x = _v49
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v48.frame_id = str[start:end].decode('utf-8')
        else:
          _v48.frame_id = str[start:end]
        _v50 = _v47.pose
        _v51 = _v50.position
        _x = _v51
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v52 = _v50.orientation
        _x = _v52
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width,) = _get_struct_3d().unpack(str[start:end])
        self.grasps.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v53 = val1.outer_dimensions
        _x = _v53
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v54 = val1.inner_dimensions
        _x = _v54
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v55 = val1.rim_thickness
        _x = _v55
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v56 = val1.pose
        _v57 = _v56.header
        buff.write(_get_struct_I().pack(_v57.seq))
        _v58 = _v57.stamp
        _x = _v58
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v57.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v59 = _v56.pose
        _v60 = _v59.position
        _x = _v60
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v61 = _v59.orientation
        _x = _v61
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      length = len(self.items)
      buff.write(_struct_I.pack(length))
      for val1 in self.items:
        length = len(val1.grasp_uuids)
        buff.write(_struct_I.pack(length))
        for val2 in val1.grasp_uuids:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
        _v62 = val1.pose
        _v63 = _v62.position
        _x = _v63
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v64 = _v62.orientation
        _x = _v64
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.pose_frame
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v65 = val1.rectangle
        _x = _v65
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v66 = val1.timestamp
        _x = _v66
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      length = len(self.grasps)
      buff.write(_struct_I.pack(length))
      for val1 in self.grasps:
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.item_uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v67 = val1.pose
        _v68 = _v67.header
        buff.write(_get_struct_I().pack(_v68.seq))
        _v69 = _v68.stamp
        _x = _v69
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v68.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v70 = _v67.pose
        _v71 = _v70.position
        _x = _v71
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v72 = _v70.orientation
        _x = _v72
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1
        buff.write(_get_struct_3d().pack(_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width))
      buff.write(_get_struct_h().pack(self.return_code.value))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = None
      if self.items is None:
        self.items = None
      if self.grasps is None:
        self.grasps = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.LoadCarrier()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8')
        else:
          val1.id = str[start:end]
        _v73 = val1.outer_dimensions
        _x = _v73
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v74 = val1.inner_dimensions
        _x = _v74
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v75 = val1.rim_thickness
        _x = _v75
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v76 = val1.pose
        _v77 = _v76.header
        start = end
        end += 4
        (_v77.seq,) = _get_struct_I().unpack(str[start:end])
        _v78 = _v77.stamp
        _x = _v78
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v77.frame_id = str[start:end].decode('utf-8')
        else:
          _v77.frame_id = str[start:end]
        _v79 = _v76.pose
        _v80 = _v79.position
        _x = _v80
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v81 = _v79.orientation
        _x = _v81
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.load_carriers.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.items = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.BoxItem()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.grasp_uuids = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.grasp_uuids.append(val2)
        _v82 = val1.pose
        _v83 = _v82.position
        _x = _v83
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v84 = _v82.orientation
        _x = _v84
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.pose_frame = str[start:end].decode('utf-8')
        else:
          val1.pose_frame = str[start:end]
        _v85 = val1.rectangle
        _x = _v85
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v86 = val1.timestamp
        _x = _v86
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8')
        else:
          val1.uuid = str[start:end]
        self.items.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.grasps = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.SuctionGrasp()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8')
        else:
          val1.uuid = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.item_uuid = str[start:end].decode('utf-8')
        else:
          val1.item_uuid = str[start:end]
        _v87 = val1.pose
        _v88 = _v87.header
        start = end
        end += 4
        (_v88.seq,) = _get_struct_I().unpack(str[start:end])
        _v89 = _v88.stamp
        _x = _v89
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v88.frame_id = str[start:end].decode('utf-8')
        else:
          _v88.frame_id = str[start:end]
        _v90 = _v87.pose
        _v91 = _v90.position
        _x = _v91
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v92 = _v90.orientation
        _x = _v92
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        _x = val1
        start = end
        end += 24
        (_x.quality, _x.max_suction_surface_length, _x.max_suction_surface_width,) = _get_struct_3d().unpack(str[start:end])
        self.grasps.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
class ComputeBoxGrasps(object):
  _type          = 'rc_pick_client/ComputeBoxGrasps'
  _md5sum = '109ad7f3407573d37301577ee34bcb5b'
  _request_class  = ComputeBoxGraspsRequest
  _response_class = ComputeBoxGraspsResponse
