# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/DetectBoxItemsRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import rc_pick_client.msg

class DetectBoxItemsRequest(genpy.Message):
  _md5sum = "dc87be450a8690d703967b97eb31e480"
  _type = "rc_pick_client/DetectBoxItemsRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """







BoxModel[] item_models


Compartment load_carrier_compartment


string pose_frame


string region_of_interest_id


string load_carrier_id


geometry_msgs/Pose robot_pose


================================================================================
MSG: rc_pick_client/BoxModel
# Definition of a box model for the boxpick component

# Required
string type

# Required
RangeRectangle rectangle

================================================================================
MSG: rc_pick_client/RangeRectangle
# Definition of a rectangle with minimum and maximum dimensions

Rectangle min_dimensions
Rectangle max_dimensions

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: rc_pick_client/Compartment
# Definition of a compartment (Primitive type without pose_frame and type)
# type is implicit since currently only Box type is supported
# the pose is relative to the pose_frame of the object including the compartment

# Required
# string type

# Supported types
# All primitives are defined to have their bounding boxes centered around (0,0,0)
string BOX=BOX
# string SPHERE=SPHERE
# string CYLINDER=CYLINDER
# string CONE=CONE

# Optional: if not specified, the pose is relative to the pose_frame of the object including the primitive
# string pose_frame

# Optional: identity transformation assumed if not provided
geometry_msgs/Pose pose

# Only one of those required depending on the selected type
Box box
# Sphere sphere
# Cylinder cylinder
# Cone cone

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z
"""
  __slots__ = ['item_models','load_carrier_compartment','pose_frame','region_of_interest_id','load_carrier_id','robot_pose']
  _slot_types = ['rc_pick_client/BoxModel[]','rc_pick_client/Compartment','string','string','string','geometry_msgs/Pose']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       item_models,load_carrier_compartment,pose_frame,region_of_interest_id,load_carrier_id,robot_pose

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DetectBoxItemsRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.item_models is None:
        self.item_models = []
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.pose_frame is None:
        self.pose_frame = ''
      if self.region_of_interest_id is None:
        self.region_of_interest_id = ''
      if self.load_carrier_id is None:
        self.load_carrier_id = ''
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
    else:
      self.item_models = []
      self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      self.pose_frame = ''
      self.region_of_interest_id = ''
      self.load_carrier_id = ''
      self.robot_pose = geometry_msgs.msg.Pose()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.item_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.item_models:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v1 = val1.rectangle
        _v2 = _v1.min_dimensions
        _x = _v2
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v3 = _v1.max_dimensions
        _x = _v3
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_10d().pack(_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z))
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.load_carrier_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.item_models is None:
        self.item_models = None
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.item_models = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.BoxModel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        _v4 = val1.rectangle
        _v5 = _v4.min_dimensions
        _x = _v5
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v6 = _v4.max_dimensions
        _x = _v6
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        self.item_models.append(val1)
      _x = self
      start = end
      end += 80
      (_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier_id = str[start:end].decode('utf-8')
      else:
        self.load_carrier_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.item_models)
      buff.write(_struct_I.pack(length))
      for val1 in self.item_models:
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v7 = val1.rectangle
        _v8 = _v7.min_dimensions
        _x = _v8
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v9 = _v7.max_dimensions
        _x = _v9
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
      _x = self
      buff.write(_get_struct_10d().pack(_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z))
      _x = self.pose_frame
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.region_of_interest_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.load_carrier_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_7d().pack(_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.item_models is None:
        self.item_models = None
      if self.load_carrier_compartment is None:
        self.load_carrier_compartment = rc_pick_client.msg.Compartment()
      if self.robot_pose is None:
        self.robot_pose = geometry_msgs.msg.Pose()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.item_models = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.BoxModel()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        _v10 = val1.rectangle
        _v11 = _v10.min_dimensions
        _x = _v11
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v12 = _v10.max_dimensions
        _x = _v12
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        self.item_models.append(val1)
      _x = self
      start = end
      end += 80
      (_x.load_carrier_compartment.pose.position.x, _x.load_carrier_compartment.pose.position.y, _x.load_carrier_compartment.pose.position.z, _x.load_carrier_compartment.pose.orientation.x, _x.load_carrier_compartment.pose.orientation.y, _x.load_carrier_compartment.pose.orientation.z, _x.load_carrier_compartment.pose.orientation.w, _x.load_carrier_compartment.box.x, _x.load_carrier_compartment.box.y, _x.load_carrier_compartment.box.z,) = _get_struct_10d().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.pose_frame = str[start:end].decode('utf-8')
      else:
        self.pose_frame = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.region_of_interest_id = str[start:end].decode('utf-8')
      else:
        self.region_of_interest_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.load_carrier_id = str[start:end].decode('utf-8')
      else:
        self.load_carrier_id = str[start:end]
      _x = self
      start = end
      end += 56
      (_x.robot_pose.position.x, _x.robot_pose.position.y, _x.robot_pose.position.z, _x.robot_pose.orientation.x, _x.robot_pose.orientation.y, _x.robot_pose.orientation.z, _x.robot_pose.orientation.w,) = _get_struct_7d().unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_7d = None
def _get_struct_7d():
    global _struct_7d
    if _struct_7d is None:
        _struct_7d = struct.Struct("<7d")
    return _struct_7d
_struct_10d = None
def _get_struct_10d():
    global _struct_10d
    if _struct_10d is None:
        _struct_10d = struct.Struct("<10d")
    return _struct_10d
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from rc_pick_client/DetectBoxItemsResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import rc_common_msgs.msg
import geometry_msgs.msg
import genpy
import rc_pick_client.msg
import std_msgs.msg

class DetectBoxItemsResponse(genpy.Message):
  _md5sum = "6c3b1a9882583c78880c28d6a3096ef4"
  _type = "rc_pick_client/DetectBoxItemsResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """
BoxItem[] items

time timestamp

LoadCarrier[] load_carriers

rc_common_msgs/ReturnCode return_code


================================================================================
MSG: rc_pick_client/BoxItem
# Definition of a box item for the boxpick component

# Optional
string[] grasp_uuids

# Required. The pose of the box item
geometry_msgs/Pose pose

# Required
string pose_frame

# Required
Rectangle rectangle

# Required
time timestamp

# Required
string type

# Required
string uuid

================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: rc_pick_client/Rectangle
# Definition of a rectangle

float64 x
float64 y

================================================================================
MSG: rc_pick_client/LoadCarrier
# This represents a load carrier by its geometry and its pose in the pose_frame reference frame

string id

# Required
Box outer_dimensions

# Required
Box inner_dimensions

# Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
Rectangle rim_thickness

geometry_msgs/PoseStamped pose

================================================================================
MSG: rc_pick_client/Box
# Definition of a box

float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/PoseStamped
# A Pose with reference coordinate frame and timestamp
Header header
Pose pose

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id

================================================================================
MSG: rc_common_msgs/ReturnCode
# This message shall be used in the response of services as a field called return_code.
# Confer to ReturnCodeConsts message for commonly used return code definitions.

# return codes
# >=0 - success
# < 0 - failure

# return code
int16 value

# return message
string message
"""
  __slots__ = ['items','timestamp','load_carriers','return_code']
  _slot_types = ['rc_pick_client/BoxItem[]','time','rc_pick_client/LoadCarrier[]','rc_common_msgs/ReturnCode']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       items,timestamp,load_carriers,return_code

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DetectBoxItemsResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.items is None:
        self.items = []
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = []
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
    else:
      self.items = []
      self.timestamp = genpy.Time()
      self.load_carriers = []
      self.return_code = rc_common_msgs.msg.ReturnCode()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      length = len(self.items)
      buff.write(_struct_I.pack(length))
      for val1 in self.items:
        length = len(val1.grasp_uuids)
        buff.write(_struct_I.pack(length))
        for val2 in val1.grasp_uuids:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
        _v13 = val1.pose
        _v14 = _v13.position
        _x = _v14
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v15 = _v13.orientation
        _x = _v15
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.pose_frame
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v16 = val1.rectangle
        _x = _v16
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v17 = val1.timestamp
        _x = _v17
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v18 = val1.outer_dimensions
        _x = _v18
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v19 = val1.inner_dimensions
        _x = _v19
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v20 = val1.rim_thickness
        _x = _v20
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v21 = val1.pose
        _v22 = _v21.header
        buff.write(_get_struct_I().pack(_v22.seq))
        _v23 = _v22.stamp
        _x = _v23
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v22.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v24 = _v21.pose
        _v25 = _v24.position
        _x = _v25
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v26 = _v24.orientation
        _x = _v26
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      buff.write(_get_struct_h().pack(self.return_code.value))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.items is None:
        self.items = None
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.items = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.BoxItem()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.grasp_uuids = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.grasp_uuids.append(val2)
        _v27 = val1.pose
        _v28 = _v27.position
        _x = _v28
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v29 = _v27.orientation
        _x = _v29
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.pose_frame = str[start:end].decode('utf-8')
        else:
          val1.pose_frame = str[start:end]
        _v30 = val1.rectangle
        _x = _v30
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v31 = val1.timestamp
        _x = _v31
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8')
        else:
          val1.uuid = str[start:end]
        self.items.append(val1)
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.LoadCarrier()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8')
        else:
          val1.id = str[start:end]
        _v32 = val1.outer_dimensions
        _x = _v32
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v33 = val1.inner_dimensions
        _x = _v33
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v34 = val1.rim_thickness
        _x = _v34
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v35 = val1.pose
        _v36 = _v35.header
        start = end
        end += 4
        (_v36.seq,) = _get_struct_I().unpack(str[start:end])
        _v37 = _v36.stamp
        _x = _v37
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v36.frame_id = str[start:end].decode('utf-8')
        else:
          _v36.frame_id = str[start:end]
        _v38 = _v35.pose
        _v39 = _v38.position
        _x = _v39
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v40 = _v38.orientation
        _x = _v40
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.load_carriers.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      length = len(self.items)
      buff.write(_struct_I.pack(length))
      for val1 in self.items:
        length = len(val1.grasp_uuids)
        buff.write(_struct_I.pack(length))
        for val2 in val1.grasp_uuids:
          length = len(val2)
          if python3 or type(val2) == unicode:
            val2 = val2.encode('utf-8')
            length = len(val2)
          buff.write(struct.pack('<I%ss'%length, length, val2))
        _v41 = val1.pose
        _v42 = _v41.position
        _x = _v42
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v43 = _v41.orientation
        _x = _v43
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
        _x = val1.pose_frame
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v44 = val1.rectangle
        _x = _v44
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v45 = val1.timestamp
        _x = _v45
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = val1.type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _x = val1.uuid
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_get_struct_2I().pack(_x.timestamp.secs, _x.timestamp.nsecs))
      length = len(self.load_carriers)
      buff.write(_struct_I.pack(length))
      for val1 in self.load_carriers:
        _x = val1.id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v46 = val1.outer_dimensions
        _x = _v46
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v47 = val1.inner_dimensions
        _x = _v47
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v48 = val1.rim_thickness
        _x = _v48
        buff.write(_get_struct_2d().pack(_x.x, _x.y))
        _v49 = val1.pose
        _v50 = _v49.header
        buff.write(_get_struct_I().pack(_v50.seq))
        _v51 = _v50.stamp
        _x = _v51
        buff.write(_get_struct_2I().pack(_x.secs, _x.nsecs))
        _x = _v50.frame_id
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.pack('<I%ss'%length, length, _x))
        _v52 = _v49.pose
        _v53 = _v52.position
        _x = _v53
        buff.write(_get_struct_3d().pack(_x.x, _x.y, _x.z))
        _v54 = _v52.orientation
        _x = _v54
        buff.write(_get_struct_4d().pack(_x.x, _x.y, _x.z, _x.w))
      buff.write(_get_struct_h().pack(self.return_code.value))
      _x = self.return_code.message
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.items is None:
        self.items = None
      if self.timestamp is None:
        self.timestamp = genpy.Time()
      if self.load_carriers is None:
        self.load_carriers = None
      if self.return_code is None:
        self.return_code = rc_common_msgs.msg.ReturnCode()
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.items = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.BoxItem()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        val1.grasp_uuids = []
        for i in range(0, length):
          start = end
          end += 4
          (length,) = _struct_I.unpack(str[start:end])
          start = end
          end += length
          if python3:
            val2 = str[start:end].decode('utf-8')
          else:
            val2 = str[start:end]
          val1.grasp_uuids.append(val2)
        _v55 = val1.pose
        _v56 = _v55.position
        _x = _v56
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v57 = _v55.orientation
        _x = _v57
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.pose_frame = str[start:end].decode('utf-8')
        else:
          val1.pose_frame = str[start:end]
        _v58 = val1.rectangle
        _x = _v58
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v59 = val1.timestamp
        _x = _v59
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.type = str[start:end].decode('utf-8')
        else:
          val1.type = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.uuid = str[start:end].decode('utf-8')
        else:
          val1.uuid = str[start:end]
        self.items.append(val1)
      _x = self
      start = end
      end += 8
      (_x.timestamp.secs, _x.timestamp.nsecs,) = _get_struct_2I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.load_carriers = []
      for i in range(0, length):
        val1 = rc_pick_client.msg.LoadCarrier()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.id = str[start:end].decode('utf-8')
        else:
          val1.id = str[start:end]
        _v60 = val1.outer_dimensions
        _x = _v60
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v61 = val1.inner_dimensions
        _x = _v61
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v62 = val1.rim_thickness
        _x = _v62
        start = end
        end += 16
        (_x.x, _x.y,) = _get_struct_2d().unpack(str[start:end])
        _v63 = val1.pose
        _v64 = _v63.header
        start = end
        end += 4
        (_v64.seq,) = _get_struct_I().unpack(str[start:end])
        _v65 = _v64.stamp
        _x = _v65
        start = end
        end += 8
        (_x.secs, _x.nsecs,) = _get_struct_2I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          _v64.frame_id = str[start:end].decode('utf-8')
        else:
          _v64.frame_id = str[start:end]
        _v66 = _v63.pose
        _v67 = _v66.position
        _x = _v67
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _get_struct_3d().unpack(str[start:end])
        _v68 = _v66.orientation
        _x = _v68
        start = end
        end += 32
        (_x.x, _x.y, _x.z, _x.w,) = _get_struct_4d().unpack(str[start:end])
        self.load_carriers.append(val1)
      start = end
      end += 2
      (self.return_code.value,) = _get_struct_h().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.return_code.message = str[start:end].decode('utf-8')
      else:
        self.return_code.message = str[start:end]
      self.timestamp.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_h = None
def _get_struct_h():
    global _struct_h
    if _struct_h is None:
        _struct_h = struct.Struct("<h")
    return _struct_h
_struct_2d = None
def _get_struct_2d():
    global _struct_2d
    if _struct_2d is None:
        _struct_2d = struct.Struct("<2d")
    return _struct_2d
_struct_4d = None
def _get_struct_4d():
    global _struct_4d
    if _struct_4d is None:
        _struct_4d = struct.Struct("<4d")
    return _struct_4d
_struct_2I = None
def _get_struct_2I():
    global _struct_2I
    if _struct_2I is None:
        _struct_2I = struct.Struct("<2I")
    return _struct_2I
_struct_3d = None
def _get_struct_3d():
    global _struct_3d
    if _struct_3d is None:
        _struct_3d = struct.Struct("<3d")
    return _struct_3d
class DetectBoxItems(object):
  _type          = 'rc_pick_client/DetectBoxItems'
  _md5sum = 'aa8c1b4c36875643d86a59d7c25141e1'
  _request_class  = DetectBoxItemsRequest
  _response_class = DetectBoxItemsResponse
