// Auto-generated. Do not edit!

// (in-package rc_pick_client.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Rectangle = require('./Rectangle.js');
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

class BoxItem {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.grasp_uuids = null;
      this.pose = null;
      this.pose_frame = null;
      this.rectangle = null;
      this.timestamp = null;
      this.type = null;
      this.uuid = null;
    }
    else {
      if (initObj.hasOwnProperty('grasp_uuids')) {
        this.grasp_uuids = initObj.grasp_uuids
      }
      else {
        this.grasp_uuids = [];
      }
      if (initObj.hasOwnProperty('pose')) {
        this.pose = initObj.pose
      }
      else {
        this.pose = new geometry_msgs.msg.Pose();
      }
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('rectangle')) {
        this.rectangle = initObj.rectangle
      }
      else {
        this.rectangle = new Rectangle();
      }
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('type')) {
        this.type = initObj.type
      }
      else {
        this.type = '';
      }
      if (initObj.hasOwnProperty('uuid')) {
        this.uuid = initObj.uuid
      }
      else {
        this.uuid = '';
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type BoxItem
    // Serialize message field [grasp_uuids]
    bufferOffset = _arraySerializer.string(obj.grasp_uuids, buffer, bufferOffset, null);
    // Serialize message field [pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.pose, buffer, bufferOffset);
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [rectangle]
    bufferOffset = Rectangle.serialize(obj.rectangle, buffer, bufferOffset);
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [type]
    bufferOffset = _serializer.string(obj.type, buffer, bufferOffset);
    // Serialize message field [uuid]
    bufferOffset = _serializer.string(obj.uuid, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type BoxItem
    let len;
    let data = new BoxItem(null);
    // Deserialize message field [grasp_uuids]
    data.grasp_uuids = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [pose]
    data.pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [rectangle]
    data.rectangle = Rectangle.deserialize(buffer, bufferOffset);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [type]
    data.type = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [uuid]
    data.uuid = _deserializer.string(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.grasp_uuids.forEach((val) => {
      length += 4 + val.length;
    });
    length += object.pose_frame.length;
    length += object.type.length;
    length += object.uuid.length;
    return length + 96;
  }

  static datatype() {
    // Returns string type for a message object
    return 'rc_pick_client/BoxItem';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '0d06b4048dd5f6532bfd45ae0a8e5329';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Definition of a box item for the boxpick component
    
    # Optional
    string[] grasp_uuids
    
    # Required. The pose of the box item
    geometry_msgs/Pose pose
    
    # Required
    string pose_frame
    
    # Required
    Rectangle rectangle
    
    # Required
    time timestamp
    
    # Required
    string type
    
    # Required
    string uuid
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new BoxItem(null);
    if (msg.grasp_uuids !== undefined) {
      resolved.grasp_uuids = msg.grasp_uuids;
    }
    else {
      resolved.grasp_uuids = []
    }

    if (msg.pose !== undefined) {
      resolved.pose = geometry_msgs.msg.Pose.Resolve(msg.pose)
    }
    else {
      resolved.pose = new geometry_msgs.msg.Pose()
    }

    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.rectangle !== undefined) {
      resolved.rectangle = Rectangle.Resolve(msg.rectangle)
    }
    else {
      resolved.rectangle = new Rectangle()
    }

    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.type !== undefined) {
      resolved.type = msg.type;
    }
    else {
      resolved.type = ''
    }

    if (msg.uuid !== undefined) {
      resolved.uuid = msg.uuid;
    }
    else {
      resolved.uuid = ''
    }

    return resolved;
    }
};

module.exports = BoxItem;
