// Auto-generated. Do not edit!

// (in-package rc_pick_client.srv)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let geometry_msgs = _finder('geometry_msgs');

//-----------------------------------------------------------

let LoadCarrier = require('../msg/LoadCarrier.js');
let rc_common_msgs = _finder('rc_common_msgs');

//-----------------------------------------------------------

class DetectLoadCarriersRequest {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.pose_frame = null;
      this.region_of_interest_id = null;
      this.load_carrier_ids = null;
      this.robot_pose = null;
    }
    else {
      if (initObj.hasOwnProperty('pose_frame')) {
        this.pose_frame = initObj.pose_frame
      }
      else {
        this.pose_frame = '';
      }
      if (initObj.hasOwnProperty('region_of_interest_id')) {
        this.region_of_interest_id = initObj.region_of_interest_id
      }
      else {
        this.region_of_interest_id = '';
      }
      if (initObj.hasOwnProperty('load_carrier_ids')) {
        this.load_carrier_ids = initObj.load_carrier_ids
      }
      else {
        this.load_carrier_ids = [];
      }
      if (initObj.hasOwnProperty('robot_pose')) {
        this.robot_pose = initObj.robot_pose
      }
      else {
        this.robot_pose = new geometry_msgs.msg.Pose();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DetectLoadCarriersRequest
    // Serialize message field [pose_frame]
    bufferOffset = _serializer.string(obj.pose_frame, buffer, bufferOffset);
    // Serialize message field [region_of_interest_id]
    bufferOffset = _serializer.string(obj.region_of_interest_id, buffer, bufferOffset);
    // Serialize message field [load_carrier_ids]
    bufferOffset = _arraySerializer.string(obj.load_carrier_ids, buffer, bufferOffset, null);
    // Serialize message field [robot_pose]
    bufferOffset = geometry_msgs.msg.Pose.serialize(obj.robot_pose, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DetectLoadCarriersRequest
    let len;
    let data = new DetectLoadCarriersRequest(null);
    // Deserialize message field [pose_frame]
    data.pose_frame = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [region_of_interest_id]
    data.region_of_interest_id = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [load_carrier_ids]
    data.load_carrier_ids = _arrayDeserializer.string(buffer, bufferOffset, null)
    // Deserialize message field [robot_pose]
    data.robot_pose = geometry_msgs.msg.Pose.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.pose_frame.length;
    length += object.region_of_interest_id.length;
    object.load_carrier_ids.forEach((val) => {
      length += 4 + val.length;
    });
    return length + 68;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_pick_client/DetectLoadCarriersRequest';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '109900b254afe0f701853e7e76fc3465';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    
    
    
    
    
    
    
    string pose_frame
    
    
    string region_of_interest_id
    
    
    string[] load_carrier_ids
    
    
    geometry_msgs/Pose robot_pose
    
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DetectLoadCarriersRequest(null);
    if (msg.pose_frame !== undefined) {
      resolved.pose_frame = msg.pose_frame;
    }
    else {
      resolved.pose_frame = ''
    }

    if (msg.region_of_interest_id !== undefined) {
      resolved.region_of_interest_id = msg.region_of_interest_id;
    }
    else {
      resolved.region_of_interest_id = ''
    }

    if (msg.load_carrier_ids !== undefined) {
      resolved.load_carrier_ids = msg.load_carrier_ids;
    }
    else {
      resolved.load_carrier_ids = []
    }

    if (msg.robot_pose !== undefined) {
      resolved.robot_pose = geometry_msgs.msg.Pose.Resolve(msg.robot_pose)
    }
    else {
      resolved.robot_pose = new geometry_msgs.msg.Pose()
    }

    return resolved;
    }
};

class DetectLoadCarriersResponse {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.timestamp = null;
      this.load_carriers = null;
      this.return_code = null;
    }
    else {
      if (initObj.hasOwnProperty('timestamp')) {
        this.timestamp = initObj.timestamp
      }
      else {
        this.timestamp = {secs: 0, nsecs: 0};
      }
      if (initObj.hasOwnProperty('load_carriers')) {
        this.load_carriers = initObj.load_carriers
      }
      else {
        this.load_carriers = [];
      }
      if (initObj.hasOwnProperty('return_code')) {
        this.return_code = initObj.return_code
      }
      else {
        this.return_code = new rc_common_msgs.msg.ReturnCode();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type DetectLoadCarriersResponse
    // Serialize message field [timestamp]
    bufferOffset = _serializer.time(obj.timestamp, buffer, bufferOffset);
    // Serialize message field [load_carriers]
    // Serialize the length for message field [load_carriers]
    bufferOffset = _serializer.uint32(obj.load_carriers.length, buffer, bufferOffset);
    obj.load_carriers.forEach((val) => {
      bufferOffset = LoadCarrier.serialize(val, buffer, bufferOffset);
    });
    // Serialize message field [return_code]
    bufferOffset = rc_common_msgs.msg.ReturnCode.serialize(obj.return_code, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type DetectLoadCarriersResponse
    let len;
    let data = new DetectLoadCarriersResponse(null);
    // Deserialize message field [timestamp]
    data.timestamp = _deserializer.time(buffer, bufferOffset);
    // Deserialize message field [load_carriers]
    // Deserialize array length for message field [load_carriers]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.load_carriers = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.load_carriers[i] = LoadCarrier.deserialize(buffer, bufferOffset)
    }
    // Deserialize message field [return_code]
    data.return_code = rc_common_msgs.msg.ReturnCode.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    object.load_carriers.forEach((val) => {
      length += LoadCarrier.getMessageSize(val);
    });
    length += rc_common_msgs.msg.ReturnCode.getMessageSize(object.return_code);
    return length + 12;
  }

  static datatype() {
    // Returns string type for a service object
    return 'rc_pick_client/DetectLoadCarriersResponse';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '2b275f978e663a72c238766a139d4703';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    
    time timestamp
    
    LoadCarrier[] load_carriers
    
    rc_common_msgs/ReturnCode return_code
    
    
    ================================================================================
    MSG: rc_pick_client/LoadCarrier
    # This represents a load carrier by its geometry and its pose in the pose_frame reference frame
    
    string id
    
    # Required
    Box outer_dimensions
    
    # Required
    Box inner_dimensions
    
    # Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
    Rectangle rim_thickness
    
    geometry_msgs/PoseStamped pose
    
    ================================================================================
    MSG: rc_pick_client/Box
    # Definition of a box
    
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: rc_pick_client/Rectangle
    # Definition of a rectangle
    
    float64 x
    float64 y
    
    ================================================================================
    MSG: geometry_msgs/PoseStamped
    # A Pose with reference coordinate frame and timestamp
    Header header
    Pose pose
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    string frame_id
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    ================================================================================
    MSG: rc_common_msgs/ReturnCode
    # This message shall be used in the response of services as a field called return_code.
    # Confer to ReturnCodeConsts message for commonly used return code definitions.
    
    # return codes
    # >=0 - success
    # < 0 - failure
    
    # return code
    int16 value
    
    # return message
    string message
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new DetectLoadCarriersResponse(null);
    if (msg.timestamp !== undefined) {
      resolved.timestamp = msg.timestamp;
    }
    else {
      resolved.timestamp = {secs: 0, nsecs: 0}
    }

    if (msg.load_carriers !== undefined) {
      resolved.load_carriers = new Array(msg.load_carriers.length);
      for (let i = 0; i < resolved.load_carriers.length; ++i) {
        resolved.load_carriers[i] = LoadCarrier.Resolve(msg.load_carriers[i]);
      }
    }
    else {
      resolved.load_carriers = []
    }

    if (msg.return_code !== undefined) {
      resolved.return_code = rc_common_msgs.msg.ReturnCode.Resolve(msg.return_code)
    }
    else {
      resolved.return_code = new rc_common_msgs.msg.ReturnCode()
    }

    return resolved;
    }
};

module.exports = {
  Request: DetectLoadCarriersRequest,
  Response: DetectLoadCarriersResponse,
  md5sum() { return '111e6b663e17a92df059d27b5c87a844'; },
  datatype() { return 'rc_pick_client/DetectLoadCarriers'; }
};
